C***********************************************************************
C
C     Fortran-definitions for PCL (Performance Counter Library)
C
C***********************************************************************

C*** maximum values
      INTEGER PCL_MAX_EVENT,PCL_MAX_EVENT_PER_CALL,PCL_MAX_NESTING_LEVEL
      PARAMETER(PCL_MAX_EVENT=61,
     +          PCL_MAX_EVENT_PER_CALL=4,
     +          PCL_MAX_NESTING_LEVEL=16)

C*** return codes
      INTEGER PCL_SUCCESS,PCL_NOT_SUPPORTED,PCL_TOO_MANY_EVENTS,
     +        PCL_TOO_MANY_NESTINGS,PCL_ILL_NESTING,PCL_ILL_EVENT,
     +        PCL_MODE_NOT_SUPPORTED,PCL_FAILURE
      PARAMETER(PCL_SUCCESS=0,
     +          PCL_NOT_SUPPORTED=-1,
     +          PCL_TOO_MANY_EVENTS=-2,
     +          PCL_TOO_MANY_NESTINGS=-3,
     +          PCL_ILL_NESTING=-4,
     +          PCL_ILL_EVENT=-5,
     +          PCL_MODE_NOT_SUPPORTED=-6,
     +          PCL_FAILURE=-7
     +     )

C*** define what to count
      INTEGER PCL_MODE_USER,PCL_MODE_SYSTEM,PCL_MODE_USER_SYSTEM
      PARAMETER(PCL_MODE_USER=1,
     +          PCL_MODE_SYSTEM=2,
     +          PCL_MODE_USER_SYSTEM=3
     +     )

C*** events
      INTEGER PCL_L1CACHE_READ,PCL_L1CACHE_WRITE,PCL_L1CACHE_READWRITE,
     +        PCL_L1CACHE_HIT,PCL_L1CACHE_MISS,PCL_L1CACHE_USED_LINES,
     +        PCL_L1DCACHE_READ,PCL_L1DCACHE_WRITE,
     +        PCL_L1DCACHE_READWRITE,PCL_L1DCACHE_HIT,
     +        PCL_L1DCACHE_MISS,PCL_L1DCACHE_USED_LINES,
     +        PCL_L1ICACHE_READ,PCL_L1ICACHE_WRITE,
     +        PCL_L1ICACHE_READWRITE,PCL_L1ICACHE_HIT,
     +        PCL_L1ICACHE_MISS,PCL_L1ICACHE_USED_LINES,
     +        PCL_L2CACHE_READ,PCL_L2CACHE_WRITE,PCL_L2CACHE_READWRITE,
     +        PCL_L2CACHE_HIT,PCL_L2CACHE_MISS,PCL_L2CACHE_USED_LINES,
     +        PCL_L2DCACHE_READ,PCL_L2DCACHE_WRITE,
     +        PCL_L2DCACHE_READWRITE,PCL_L2DCACHE_HIT,
     +        PCL_L2DCACHE_MISS,PCL_L2DCACHE_USED_LINES,
     +        PCL_L2ICACHE_READ,PCL_L2ICACHE_WRITE,
     +        PCL_L2ICACHE_READWRITE,PCL_L2ICACHE_HIT,PCL_L2ICACHE_MISS,
     +        PCL_L2ICACHE_USED_LINES,PCL_TLB_HIT,PCL_TLB_MISS,
     +        PCL_ITLB_HIT,PCL_ITLB_MISS, PCL_DTLB_HIT,PCL_DTLB_MISS,
     +        PCL_CYCLES,PCL_INTEGER_INSTR,PCL_FP_INSTR,PCL_LOAD_INSTR,
     +        PCL_STORE_INSTR,PCL_LOADSTORE_INSTR,PCL_INSTR,
     +        PCL_JUMP_SUCCESS,PCL_JUMP_UNSUCCESS,PCL_JUMP,
     +        PCL_ATOMIC_SUCCESS,PCL_ATOMIC_UNSUCCESS,PCL_ATOMIC,
     +        PCL_STALL_INTEGER,PCL_STALL_FP,PCL_STALL_JUMP,
     +        PCL_STALL_LOAD,PCL_STALL_STORE,PCL_STALL
      PARAMETER(PCL_L1CACHE_READ=0,
     +          PCL_L1CACHE_WRITE=1,
     +          PCL_L1CACHE_READWRITE=2,
     +          PCL_L1CACHE_HIT=3,
     +          PCL_L1CACHE_MISS=4,
     +          PCL_L1CACHE_USED_LINES=5,
     +          PCL_L1DCACHE_READ=6,
     +          PCL_L1DCACHE_WRITE=7,
     +          PCL_L1DCACHE_READWRITE=8,
     +          PCL_L1DCACHE_HIT=9,
     +          PCL_L1DCACHE_MISS=10,
     +          PCL_L1DCACHE_USED_LINES=11,
     +          PCL_L1ICACHE_READ=12,
     +          PCL_L1ICACHE_WRITE=13,
     +          PCL_L1ICACHE_READWRITE=14,
     +          PCL_L1ICACHE_HIT=15,
     +          PCL_L1ICACHE_MISS=16,
     +          PCL_L1ICACHE_USED_LINES=17,
     +          PCL_L2CACHE_READ=18,
     +          PCL_L2CACHE_WRITE=19,
     +          PCL_L2CACHE_READWRITE=20,
     +          PCL_L2CACHE_HIT=21,
     +          PCL_L2CACHE_MISS=22,
     +          PCL_L2CACHE_USED_LINES=23,
     +          PCL_L2DCACHE_READ=24,
     +          PCL_L2DCACHE_WRITE=25,
     +          PCL_L2DCACHE_READWRITE=26,
     +          PCL_L2DCACHE_HIT=27,
     +          PCL_L2DCACHE_MISS=28,
     +          PCL_L2DCACHE_USED_LINES=29,
     +          PCL_L2ICACHE_READ=30,
     +          PCL_L2ICACHE_WRITE=31,
     +          PCL_L2ICACHE_READWRITE=32,
     +          PCL_L2ICACHE_HIT=33,
     +          PCL_L2ICACHE_MISS=34,
     +          PCL_L2ICACHE_USED_LINES=35,
     +          PCL_TLB_HIT=36,
     +          PCL_TLB_MISS=37,
     +          PCL_ITLB_HIT=38,
     +          PCL_ITLB_MISS=39,
     +          PCL_DTLB_HIT=40,
     +          PCL_DTLB_MISS=41,
     +          PCL_CYCLES=42,
     +          PCL_INTEGER_INSTR=43,
     +          PCL_FP_INSTR=44,
     +          PCL_LOAD_INSTR=45,
     +          PCL_STORE_INSTR=46,
     +          PCL_LOADSTORE_INSTR=47,
     +          PCL_INSTR=48,
     +          PCL_JUMP_SUCCESS=49,
     +          PCL_JUMP_UNSUCCESS=50,
     +          PCL_JUMP=51,
     +          PCL_ATOMIC_SUCCESS=52,
     +          PCL_ATOMIC_UNSUCCESS=53,
     +          PCL_ATOMIC=54,
     +          PCL_STALL_INTEGER=55,
     +          PCL_STALL_FP=56,
     +          PCL_STALL_JUMP=57,
     +          PCL_STALL_LOAD=58,
     +          PCL_STALL_STORE=59,
     +          PCL_STALL=60
     +     )

C***********************************************************************
